<?PHP

session_start();

/* load settings */
if (!isset($_CONFIG))
    require 'config.php';

/* define constants */
require 'chessconstants.php';

/* include outside functions */
if (!isset($_CHESSUTILS))
    require 'chessutils.php';
require 'gui.php';
require 'chessdb.php';
require 'move.php';
require 'undo.php';
include_once('chat.php');

/* allow WebChess to be run on PHP systems < 4.1.0, using old http vars */
fixOldPHPVersions();

/* check session status */
require 'sessioncheck.php';

/* check if loading game */
if (isset($_POST['gameID']))
    $_SESSION['gameID'] = $_POST['gameID'];

/* debug flag */
define ("DEBUG", 0);

/* connect to database */
require 'connectdb.php';


/* get White's nick */
$tmpNick = mysql_query("SELECT nick FROM players, games WHERE playerID = whitePlayer AND gameID = " . $_SESSION['gameID']);
$WhiteNick = mysql_result($tmpNick, 0);


/* get Black's nick */
$tmpNick = mysql_query("SELECT nick FROM players, games WHERE playerID = blackPlayer AND gameID = " . $_SESSION['gameID']);
$BlackNick = mysql_result($tmpNick, 0);



/* load game */
$isInCheck = ($_POST['isInCheck'] == 'true');
$isCheckMate = false;
$isPromoting = false;
$isUndoing = false;
loadHistory();
loadGame();
processMessages();
	
// save player's message into the database
saveMessage();

if ($isUndoing)	{
    doUndo();
    saveGame();
}elseif (($_POST['promotion'] != "") && ($_POST['toRow'] != "") && ($_POST['toCol'] != "")){
    savePromotion();
    $board[$_POST['toRow']][$_POST['toCol']] = $_POST['promotion'] | ($board[$_POST['toRow']][$_POST['toCol']] & BLACK);
    saveGame();
}elseif (($_POST['fromRow'] != "") && ($_POST['fromCol'] != "") && ($_POST['toRow'] != "") && ($_POST['toCol'] != "")){
    /* ensure it's the current player moving				 */
    /* NOTE: if not, this will currently ignore the command...               */
    /*       perhaps the status should be instead?                           */
    /*       (Could be confusing to player if they double-click or something */
    $tmpIsValid = true;
    if (($numMoves == -1) || ($numMoves % 2 == 1)){
	/* White's move... ensure that piece being moved is white */
	if ((($board[$_POST['fromRow']][$_POST['fromCol']] & BLACK) != 0) || ($board[$_POST['fromRow']][$_POST['fromCol']] == 0))
	    /* invalid move */
	    $tmpIsValid = false;
    }else{
	/* Black's move... ensure that piece being moved is black */
	if ((($board[$_POST['fromRow']][$_POST['fromCol']] & BLACK) != BLACK) || ($board[$_POST['fromRow']][$_POST['fromCol']] == 0))
	    /* invalid move */
	    $tmpIsValid = false;
    }

    if ($tmpIsValid){
	saveHistory();
	doMove();
	saveGame();
    }
}

############################################################
function dispPageTitle() {
############################################################
Global $numMoves, $playersColor, $isPlayersTurn;

    /* find out if it's the current player's turn */
    if (( (($numMoves == -1) || (($numMoves % 2) == 1)) && ($playersColor == "white"))
			|| ((($numMoves % 2) == 0) && ($playersColor == "black")))
    	$isPlayersTurn = true;
    else
    	$isPlayersTurn = false;

    if ($_SESSION['isSharedPC'])
    	echo "<title>WebChess</title>\n";
    else if ($isPlayersTurn)
    	echo "<title>WebChess - Your Move</title>\n";
    else
    	echo "<title>WebChess - Opponent's Move</title>\n";
}

############################################################
function dispMetaInfo() {
############################################################
Global $numMoves,$playersColor, $isPlayersTurn;
    echo "<meta HTTP-EQUIV='Pragma' CONTENT='no-cache'>\n";

    /* if it's not the player's turn, enable auto-refresh */
    if (!$isPlayersTurn && !isBoardDisabled() && !$_SESSION['isSharedPC']){
    	echo "<META HTTP-EQUIV=Refresh CONTENT='";
    	if ($_SESSION['pref_autoreload'] >= $CFG_MINAUTORELOAD)
	    echo $_SESSION['pref_autoreload'];
    	else
	    echo $CFG_MINAUTORELOAD;
	echo "; URL=chess.php?autoreload=yes'>\n";
    }
}

############################################################
function dispJSChessPage(){
############################################################
global $isGameOver;
    echo "<script type='text/javascript'>\n";
    echo "/* transfer board data to javacripts */\n";
    writeJSboard();
    writeJShistory();
    echo "if (DEBUG)\n";
    echo " alert(\"Game initilization complete!\");\n";
    echo "</script>\n";
    echo "<!-- replay history functionality -->\n";
    if ($isGameOver) {
   	writeJSReplayHistory();
   	require 'newgame.php';
   	initBoard();
    }
    echo "<script type='text/javascript' language='javascript'>\n";
    echo " function init(){\n";

    if ($isGameOver){
	echo "  MoveToEnd();\n";
    }
    echo " }\n";
    echo "</script>\n";
    echo "<!-- end replay history functionality -->\n";
    echo "<script type='text/javascript' src='javascript/chessutils.js'>\n";
    echo " /* these are utility functions used by other functions */\n";
    echo "</script>\n";
    echo "<script type='text/javascript' src='javascript/commands.js'>\n";
    echo "// these functions interact with the server\n";
    echo "</script>\n";
    echo "<script type='text/javascript' src='javascript/validation.js'>\n";
    echo "// these functions are used to test the validity of moves\n";
    echo "</script>\n";
    echo "<script type='text/javascript' src='javascript/isCheckMate.js'>\n";
    echo "// these functions are used to test the validity of moves\n";
    echo "</script>\n";
    echo "<script type='text/javascript' src='javascript/squareclicked.js'>\n";
    echo "// this is the main function that interacts with the user everytime they click on a square\n";
    echo "</script>\n";
}

############################################################
function dispCapt() {
############################################################
    $f = mysql_query("select curPiece,curColor,replaced from history where replaced > '' and gameID =  '".$_SESSION['gameID']."' order by curColor desc , replaced desc");
    $c=0;
    $d=0;
    if (mysql_num_rows($f) != 0){
    	echo "<table border='0' width='560'>\n";
    	echo " <tr><th class='th_std'>Captured pieces:</th></tr>\n";
    	echo " <tr class='tr_std'><td>\n";

    	while($row=mysql_fetch_array($f, MYSQL_ASSOC)){
    	    if(ereg("white",$row['curColor'])){
	    	$color="black_";
	    	$c++;
    	    }else{
	    	$color="white_";
    	    }
            if($c==1){
	    	echo"  </td></tr><tr class='tr_std'><td>\n";
	    	$d=0;
    	    }
            $d++;

    	    echo"<img src='images/".$_SESSION['pref_theme']."/".$color.$row['replaced'].".gif' height='30' width='30' >\n";
#    	    if(($d%8)==0){ echo "<BR>\n"; }
    	} // End while
    	echo "</td></tr></table>\n";
	echo "<br>\n";
    }
}

############################################################
function dispChessInfoBox() {
############################################################
    $infostr1  = "Note: when castling, just move the king (the rook will move automatically).";

    echo "<table border='0' width='80%'>\n";
    echo " <tr><th class='th_std'>Chess Info</th></tr>\n";
    echo " <tr class='tr_std'>\n";
    echo "  <td>".$infostr1."</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "<br>\n";
}

############################################################
function dispChessPage() {
############################################################
Global $WhiteNick, $BlackNick, $isPromoting, $isUndoRequested, $isDrawRequested ;

    echo "<html><head>\n";
    dispPageTitle();   
    echo "<link rel='stylesheet' type='text/css' href='webchess.css'>\n";
    dispMetaInfo();
    dispJSChessPage();
    echo "</head><body>\n";
    echo "<h1>". $WhiteNick . " vs " . $BlackNick . "</h1>\n";
    echo "<center>\n";
    displayMenu(); 
    echo "<table border='0'  width='80%'>\n";
    echo " <tr valign='top' align='center'>\n";
    echo "  <td>\n";
    echo "    <form name='gamedata' method='post' action='chess.php'>\n";

    drawboard(); 

    echo "    <nobr>\n";
    echo "    <input type='button' name='btnReload' value='Reload' onClick=\"window.open('chess.php','_self')\">\n";
    echo "    <input type='button' name='btnUndo' value='Request Undo' ";
    if (isBoardDisabled()) 
	echo "disabled='yes' >\n"; 
    else 
	echo "onClick='undo()'>\n";
    echo "    <input type='button' name='btnDraw' value='Request Draw' ";
    if (isBoardDisabled()) 
	echo "disabled='yes' >\n"; 
    else 
	echo "onClick='draw()'>\n";
    echo "    <input type='button' name='btnResign' value='Resign' ";
    if (isBoardDisabled()) 
	echo "disabled='yes' >\n"; 
    else 
 	echo "onClick='resigngame()'>\n";
    echo "    <input type='button' name='btnPGN' value='PGN' onClick=\"window.open('openpgn.php','_self')\">\n";
    echo "	</nobr>\n";

    echo "    <input type='hidden' name='requestUndo' value='no'>\n";
    echo "    <input type='hidden' name='requestDraw' value='no'>\n";
    echo "    <input type='hidden' name='resign' value='no'>\n";
    echo "    <input type='hidden' name='fromRow' value='";
    if (isPromoting) echo $_POST['fromRow']; 
    echo "'>\n";
    echo "    <input type='hidden' name='fromCol' value='";
    if (isPromoting) echo $_POST['fromCol'];
    echo"'>\n";
    echo "    <input type='hidden' name='toRow' value='";
    if (isPromoting) echo $_POST['toRow']; 
    echo"'>\n";
    echo "    <input type='hidden' name='toCol' value='";
    if (isPromoting) echo $_POST['toCol'];
    echo"'>\n";
    echo "    <input type='hidden' name='isInCheck' value='false'>\n";
    echo "    <input type='hidden' name='isCheckMate' value='false'>\n";
    echo "   </form>\n";

    // Display captured pieces..
    //require 'capt.php';
    dispCapt();

    showChatWindow();
    
    echo "  </td><td>\n";
    writeStatus(); 
    writeHistory(); 
    echo "  </td></tr>\n";
    echo "</table>\n";
    echo "<br>\n";
    
    dispChessInfoBox();
    dispfootNote();

    echo "</center>\n";
    echo "</body></html>\n";
}


dispChessPage();

mysql_close();
?>

