<?PHP
/* these functions are used to interact with the DB */

############################################################
function updateTimestamp(){
############################################################
    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    mysql_query("UPDATE games SET lastMove = NOW() WHERE gameID = ".$_SESSION['gameID']);
}

############################################################
function loadHistory(){
############################################################
    global $history, $numMoves;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    $allMoves = mysql_query("SELECT * FROM history WHERE gameID = ".$_SESSION['gameID']." ORDER BY timeOfMove");

    $numMoves = -1;
    while ($thisMove = mysql_fetch_array($allMoves, MYSQL_ASSOC)){
	$numMoves++;
	$history[$numMoves] = $thisMove;
    }
}

############################################################
function savePromotion(){
############################################################
    global $history, $numMoves, $isInCheck;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    if ($isInCheck){
	$tmpIsInCheck = 1;
	$history[$numMoves]['isInCheck'] = 1;
    }else
	$tmpIsInCheck = 0;

    $history[$numMoves]['promotedTo'] = getPieceName($_POST['promotion']);
    $tmpQuery = "UPDATE history SET promotedTo = '".getPieceName($_POST['promotion'])."', isInCheck = ".$tmpIsInCheck." WHERE gameID = ".$_SESSION['gameID']." AND timeOfMove = '".$history[$numMoves]['timeOfMove']."'";
    mysql_query($tmpQuery);

    updateTimestamp();

    /* if email notification is activated and move does not result in a pawn's promotion... */
    if ($CFG_USEEMAILNOTIFICATION){
	if ($history[$numMoves]['replaced'] == null)
	    $tmpReplaced = '';
	else
	    $tmpReplaced = $history[$numMoves]['replaced'];

	/* get opponent's color */
	if (($numMoves == -1) || ($numMoves % 2 == 1))
	    $oppColor = "black";
	else
	    $oppColor = "white";

	/* get opponent's player ID */
	if ($oppColor == 'white')
	    $tmpOpponentID = mysql_query("SELECT whitePlayer FROM games WHERE gameID = ".$_SESSION['gameID']);
	else
	    $tmpOpponentID = mysql_query("SELECT blackPlayer FROM games WHERE gameID = ".$_SESSION['gameID']);

	$opponentID = mysql_result($tmpOpponentID, 0);

	/* if opponent is using email notification... */
	$tmpOpponentEmail = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'emailNotification'");
	if (mysql_num_rows($tmpOpponentEmail) > 0){
	    $opponentEmail = mysql_result($tmpOpponentEmail, 0);
	    if ($opponentEmail != ''){
		/* get opponent's nick */
		$tmpOpponentNick = mysql_query("SELECT nick FROM players WHERE playerID = ".$_SESSION['playerID']);
		$opponentNick = mysql_result($tmpOpponentNick, 0);

		/* get opponent's prefered history type */
		$tmpOpponentHistory = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'history'");

		/* default to PGN */
		if (mysql_num_rows($tmpOpponentHistory) > 0)
		    $opponentHistory = mysql_result($tmpOpponentHistory, 0);
		else
		    $opponentHistory = 'pgn';

		/* notify opponent of move via email */
		if ($opponentHistory == 'pgn')
		    webchessMail('move', $opponentEmail, moveToPGNString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, $history[$numMoves]['promotedTo'], $isInCheck), $opponentNick);
		else
		    webchessMail('move', $opponentEmail, moveToVerbousString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, $history[$numMoves]['promotedTo'], $isInCheck), $opponentNick);
	    }
	}
    }
}

############################################################
function saveHistory(){
############################################################
    global $board, $isPromoting, $history, $numMoves, $isInCheck, $CFG_USEEMAILNOTIFICATION;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    /* set destination row for pawn promotion */
    if ($board[$_POST['fromRow']][$_POST['fromCol']] & BLACK)
	$targetRow = 0;
    else
	$targetRow = 7;

    /* determine if move results in pawn promotion */
    if ((($board[$_POST['fromRow']][$_POST['fromCol']] & COLOR_MASK) == PAWN) && ($_POST['toRow'] == $targetRow))
	$isPromoting = true;
    else
	$isPromoting = false;

    /* determine who's playing based on number of moves so far */
    if (($numMoves == -1) || ($numMoves % 2 == 1)){
	$curColor = "white";
	$oppColor = "black";
	$targetRow = 7;
    }else{
	$curColor = "black";
	$oppColor = "white";
	$targetRow = 0;
    }

    /* add move to history */
    $numMoves++;
    $history[$numMoves]['gamedID'] = $_SESSION['gameID'];
    $history[$numMoves]['curPiece'] = getPieceName($board[$_POST['fromRow']][$_POST['fromCol']]);
    $history[$numMoves]['curColor'] = $curColor;
    $history[$numMoves]['fromRow'] = $_POST['fromRow'];
    $history[$numMoves]['fromCol'] = $_POST['fromCol'];
    $history[$numMoves]['toRow'] = $_POST['toRow'];
    $history[$numMoves]['toCol'] = $_POST['toCol'];
    $history[$numMoves]['promotedTo'] = null;

    if ($isInCheck)
	$history[$numMoves]['isInCheck'] = 1;
    else
	$history[$numMoves]['isInCheck'] = 0;

    if (DEBUG){
	if ($history[$numMoves]['curPiece'] == '')
	    echo ("WARNING!!!  missing piece at ".$_POST['fromRow'].", ".$_POST['fromCol'].": ".$board[$_POST['fromRow']][$_POST['fromCol']]."<p>\n");
    }

    if ($board[$_POST['toRow']][$_POST['toCol']] == 0){
	/* check capture piece by en-passant */
	if (($board[$_POST['fromRow']][$_POST['fromCol']] & COLOR_MASK) == PAWN && abs($_POST['toCol'] - $_POST['fromCol']) == 1){
	    $tmpQuery = "INSERT INTO history (timeOfMove, gameID, curPiece, curColor, fromRow, fromCol, toRow, toCol, replaced, promotedTo, isInCheck) VALUES (Now(), ".$_SESSION['gameID'].", '".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."', '$curColor', ".$_POST['fromRow'].", ".$_POST['fromCol'].", ".$_POST['toRow'].", ".$_POST['toCol'].", '".getPieceName($board[$_POST['fromRow']][$_POST['toCol']])."', null, ".$history[$numMoves]['isInCheck'].")";
	    $history[$numMoves]['replaced'] = getPieceName($board[$_POST['fromRow']][$_POST['toCol']]);
	    $tmpReplaced = $history[$numMoves]['replaced'];
	}else{
	    $tmpQuery = "INSERT INTO history (timeOfMove, gameID, curPiece, curColor, fromRow, fromCol, toRow, toCol, replaced, promotedTo, isInCheck) VALUES (Now(), ".$_SESSION['gameID'].", '".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."', '$curColor', ".$_POST['fromRow'].", ".$_POST['fromCol'].", ".$_POST['toRow'].", ".$_POST['toCol'].", null, null, ".$history[$numMoves]['isInCheck'].")";
	    $history[$numMoves]['replaced'] = null;
	    $tmpReplaced = "";
	}
    }else{
	$tmpQuery = "INSERT INTO history (timeOfMove, gameID, curPiece, curColor, fromRow, fromCol, toRow, toCol, replaced, promotedTo, isInCheck) VALUES (Now(), ".$_SESSION['gameID'].", '".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."', '$curColor', ".$_POST['fromRow'].", ".$_POST['fromCol'].", ".$_POST['toRow'].", ".$_POST['toCol'].", '".getPieceName($board[$_POST['toRow']][$_POST['toCol']])."', null, ".$history[$numMoves]['isInCheck'].")";

	$history[$numMoves]['replaced'] = getPieceName($board[$_POST['toRow']][$_POST['toCol']]);
	$tmpReplaced = $history[$numMoves]['replaced'];
    }

    mysql_query($tmpQuery);

    /* if email notification is activated and move does not result in a pawn's promotion... */
    /* NOTE: moves resulting in pawn promotion are handled by savePromotion() above */
    if ($CFG_USEEMAILNOTIFICATION && !$isPromoting){
	/* get opponent's player ID */
	if ($oppColor == 'white')
	    $tmpOpponentID = mysql_query("SELECT whitePlayer FROM games WHERE gameID = ".$_SESSION['gameID']);
	else
	    $tmpOpponentID = mysql_query("SELECT blackPlayer FROM games WHERE gameID = ".$_SESSION['gameID']);

	$opponentID = mysql_result($tmpOpponentID, 0);

	/* if opponent is using email notification... */
	$tmpOpponentEmail = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'emailNotification'");
	if (mysql_num_rows($tmpOpponentEmail) > 0){
	    $opponentEmail = mysql_result($tmpOpponentEmail, 0);
	    if ($opponentEmail != ''){
		/* get opponent's nick */
		$tmpOpponentNick = mysql_query("SELECT nick FROM players WHERE playerID = ".$_SESSION['playerID']);
		$opponentNick = mysql_result($tmpOpponentNick, 0);

		/* get opponent's prefered history type */
		$tmpOpponentHistory = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'history'");

		/* default to PGN */
		if (mysql_num_rows($tmpOpponentHistory) > 0)
		    $opponentHistory = mysql_result($tmpOpponentHistory, 0);
		else
		    $opponentHistory = 'pgn';

		/* notify opponent of move via email */
		if ($opponentHistory == 'pgn')
		    webchessMail('move', $opponentEmail, moveToPGNString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, '', $isInCheck), $opponentNick);
		else
		    webchessMail('move', $opponentEmail, moveToVerbousString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, '', $isInCheck), $opponentNick);
	    }
	}
    }
}

############################################################
function loadGame(){
############################################################
    global $board, $playersColor;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    /* clear board data */
    for ($i = 0; $i < 8; $i++)
	for ($j = 0; $j < 8; $j++)
	    $board[$i][$j] = 0;

    /* get data from database */
    $pieces = mysql_query("SELECT * FROM pieces WHERE gameID = ".$_SESSION['gameID']);

    /* setup board */
    while ($thisPiece = mysql_fetch_array($pieces, MYSQL_ASSOC)){
	$board[$thisPiece["row"]][$thisPiece["col"]] = getPieceCode($thisPiece["color"], $thisPiece["piece"]);
    }

    /* get current player's color */
    $tmpQuery = "SELECT whitePlayer, blackPlayer FROM games WHERE gameID = ".$_SESSION['gameID'];
    $tmpTurns = mysql_query($tmpQuery);
    $tmpTurn = mysql_fetch_array($tmpTurns, MYSQL_ASSOC);

    if ($tmpTurn['whitePlayer'] == $_SESSION['playerID'])
	$playersColor = "white";
    else
	$playersColor = "black";
}

############################################################
function saveGame(){
############################################################
    global $board, $playersColor;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    /* clear old data */
    mysql_query("DELETE FROM pieces WHERE gameID = ".$_SESSION['gameID']);

    /* save new game data */
    /* for each row... */
    for ($i = 0; $i < 8; $i++){
	/* for each col... */
	for ($j = 0; $j < 8; $j++){
	    /* if there's a piece at that pos on the board */
	    if ($board[$i][$j] != 0){
		/* updated the database */
		if ($board[$i][$j] & BLACK)
		    $tmpColor = "black";
		else
		    $tmpColor = "white";

		$tmpPiece = getPieceName($board[$i][$j]);
		mysql_query("INSERT INTO pieces (gameID, color, piece, row, col) VALUES (".$_SESSION['gameID'].", '$tmpColor', '$tmpPiece', $i, $j)");
	    }
	}
    }
    /* update lastMove timestamp */
    updateTimestamp();
}

############################################################
function processMessages(){
############################################################
    global $isUndoRequested, $isDrawRequested, $isUndoing, $isGameOver, $isCheckMate, $playersColor, $numMoves, $statusMessage, $CFG_USEEMAILNOTIFICATION, $requestPending;

    /* old PHP versions don't have _POST, _GET and _SESSION as auto_globals */
    if (!minimum_version("4.1.0"))
	global $_POST, $_GET, $_SESSION;

    if (DEBUG)
	echo("Entering processMessages()<br>\n");

    $isUndoRequested = false;
    $isGameOver = false;

    /* find out which player (black or white) we are serving */
    /* NOTE: When playing in the same computer $playersColor is always the player who logged in first */
    if (DEBUG)
	echo("SharedPC..." . $_SESSION['isSharedPC'] . "<br>\n");
    if ($_SESSION['isSharedPC'])	// Only the player to move is active in this case
	if( ( (($numMoves == -1) || (($numMoves % 2) == 1)) && ($playersColor == "white")) ||
				((($numMoves % 2) == 0) && ($playersColor == "black")) )
	    $currentPlayer = $playersColor;
	else						// The player who logged in later is to move
	    if($playersColor == "white")
		$currentPlayer = "black";
	    else
		$currentPlayer = "white";
    else 							// The players are on different computers
	$currentPlayer = $playersColor;

    if ($currentPlayer == "white")
	$opponentColor = "black";
    else
	$opponentColor = "white";

    /* *********************************************** */
    /* queue user generated (ie: using forms) messages */
    /* *********************************************** */
    if (DEBUG)
	echo("Processing user generated (ie: form) messages...<br>\n");

    /* queue a request for an undo */
    if ($_POST['requestUndo'] == "yes"){
	//write log
	$logmess = "Request Undo for gameID: ".$_SESSION['gameID'];
	writeLog($logmess);

	/* if the two players are on the same system, execute undo immediately */
	/* NOTE: assumes the two players discussed it live before undoing */
	if ($_SESSION['isSharedPC'])
	    $isUndoing = true;
	else{
	    $tmpQuery = "INSERT INTO messages (gameID, msgType, msgStatus, destination) VALUES (".$_SESSION['gameID'].", 'undo', 'request', '".$opponentColor."')";
	    mysql_query($tmpQuery);
	}
	updateTimestamp();
    }

    /* queue a request for a draw */
    if ($_POST['requestDraw'] == "yes"){
	//write log
	$logmess = "Request Draw for gameID: ".$_SESSION['gameID'];
	writeLog($logmess);

	/* if the two players are on the same system, execute Draw immediately */
	/* NOTE: assumes the two players discussed it live before declaring the game a draw */
	if ($_SESSION['isSharedPC']){
	    $tmpQuery = "UPDATE games SET gameMessage = 'draw', messageFrom = '".$currentPlayer."' WHERE gameID = ".$_SESSION['gameID'];
	    mysql_query($tmpQuery);
	}else{
	    $tmpQuery = "INSERT INTO messages (gameID, msgType, msgStatus, destination) VALUES (".$_SESSION['gameID'].", 'draw', 'request', '".$opponentColor."')";
	    mysql_query($tmpQuery);
	}
	updateTimestamp();
    }

    /* response to a request for an undo */
    if (isset($_POST['undoResponse'])){
	if ($_POST['isUndoResponseDone'] == 'yes'){
	    if ($_POST['undoResponse'] == "yes"){
		$tmpStatus = "approved";
		$isUndoing = true;
		$logmess = "Undo Response approved for gameID: ".$_SESSION['gameID'];
	    }else{
		$tmpStatus = "denied";
		$logmess = "Undo Response denied for gameID: ".$_SESSION['gameID'];
	    }
	    //write log
	    writeLog($logmess);	    

	    $tmpQuery = "UPDATE messages SET msgStatus = '".$tmpStatus."', destination = '".$opponentColor."' WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'undo' AND msgStatus = 'request' AND destination = '".$currentPlayer."'";
	    mysql_query($tmpQuery);
	    updateTimestamp();
	}
    }

    /* response to a request for a draw */
    if (isset($_POST['drawResponse'])){
	if ($_POST['isDrawResponseDone'] == 'yes'){
	    if ($_POST['drawResponse'] == "yes"){
		$tmpStatus = "approved";
		$tmpQuery = "UPDATE games SET gameMessage = 'draw', messageFrom = '".$currentPlayer."' WHERE gameID = ".$_SESSION['gameID'];
		mysql_query($tmpQuery);
		calcEloRating(); //new EloRating function
		deleteChatMessage(); //chat
		$logmess = "Draw Response approved for gameID: ".$_SESSION['gameID'];
	    }else{
		$tmpStatus = "denied";
		$logmess = "Draw Response approved for gameID: ".$_SESSION['gameID'];
	    }
	    //write log
	    writeLog($logmess);
	    
	    $tmpQuery = "UPDATE messages SET msgStatus = '".$tmpStatus."', destination = '".$opponentColor."' WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'draw' AND msgStatus = 'request' AND destination = '".$currentPlayer."'";
	    mysql_query($tmpQuery);
	    updateTimestamp();
	}
    }

    /* resign the game */
    if ($_POST['resign'] == "yes"){
	//write log
	$logmess = "Resign the gameID: ".$_SESSION['gameID'];
	writeLog($logmess);

	$tmpQuery = "UPDATE games SET gameMessage = 'playerResigned', messageFrom = '".$currentPlayer."' WHERE gameID = ".$_SESSION['gameID'];
	mysql_query($tmpQuery);
	updateTimestamp();
	calcEloRating(); //new EloRating function
	deleteChatMessage(); //chat

	/* if email notification is activated... */
	if ($CFG_USEEMAILNOTIFICATION){
	    /* get opponent's player ID */
	    if ($currentPlayer == 'white')
		$tmpOpponentID = mysql_query("SELECT blackPlayer FROM games WHERE gameID = ".$_SESSION['gameID']);
	    else
		$tmpOpponentID = mysql_query("SELECT whitePlayer FROM games WHERE gameID = ".$_SESSION['gameID']);

	    $opponentID = mysql_result($tmpOpponentID, 0);

	    $tmpOpponentEmail = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'emailNotification'");

	    /* if opponent is using email notification... */
	    if (mysql_num_rows($tmpOpponentEmail) > 0){
		$opponentEmail = mysql_result($tmpOpponentEmail, 0);
		if ($opponentEmail != ''){
		    /* notify opponent of resignation via email */
		    webchessMail('resignation', $opponentEmail, '', $_SESSION['nick']);
		}
	    }
	}
    }

    /* ******************************************* */
    /* process queued messages (ie: from database) */
    /* ******************************************* */
    $tmpQuery = "SELECT * FROM messages WHERE gameID = ".$_SESSION['gameID']." AND destination = '".$currentPlayer."'";
    $tmpMessages = mysql_query($tmpQuery);

    while($tmpMessage = mysql_fetch_array($tmpMessages, MYSQL_ASSOC)){
	switch($tmpMessage['msgType']){
	    case 'undo':
		switch($tmpMessage['msgStatus']){
		    case 'request':
			$isUndoRequested = true;
			break;
		    case 'approved':
			$tmpQuery = "DELETE FROM messages WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'undo' AND msgStatus = 'approved' AND destination = '".$currentPlayer."'";
			mysql_query($tmpQuery);
			$statusMessage .= "Undo approved.<br>\n";
			$requestPending = false;
			break;
		    case 'denied':
			$isUndoing = false;
			$tmpQuery = "DELETE FROM messages WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'undo' AND msgStatus = 'denied' AND destination = '".$currentPlayer."'";
			mysql_query($tmpQuery);
			$statusMessage .= "Undo denied.<br>\n";
			$requestPending = false;
			break;
		}
		break;

	    case 'draw':
		switch($tmpMessage['msgStatus']){
		    case 'request':
			$isDrawRequested = true;
			break;
		    case 'approved':
			$tmpQuery = "DELETE FROM messages WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'draw' AND msgStatus = 'approved' AND destination = '".$currentPlayer."'";
			mysql_query($tmpQuery);
			$statusMessage .= "Draw approved.<br>\n";
			$requestPending = false;
			break;
		    case 'denied':
			$tmpQuery = "DELETE FROM messages WHERE gameID = ".$_SESSION['gameID']." AND msgType = 'draw' AND msgStatus = 'denied' AND destination = '".$currentPlayer."'";
			mysql_query($tmpQuery);
			$statusMessage .= "Draw denied.<br>\n";
			$requestPending = false;
			break;
		}
		break;
	}
    }

    /* requests pending */
    $tmpQuery = "SELECT * FROM messages WHERE gameID = ".$_SESSION['gameID']." AND msgStatus = 'request' AND destination = '".$opponentColor."'";
    $tmpMessages = mysql_query($tmpQuery);

    while($tmpMessage = mysql_fetch_array($tmpMessages, MYSQL_ASSOC)){
	switch($tmpMessage['msgType']){
	    case 'undo':
		$statusMessage .= "Your undo request is pending.<br>\n";
		$requestPending = true;
		break;
	    case 'draw':
		$statusMessage .= "Your request for a draw is pending.<br>\n";
		$requestPending = true;
		break;
	}
    }

    /* game level status: draws, resignations and checkmate */
    /* if checkmate, update games table */
    if ($_POST['isCheckMate'] == 'true'){
	//write log
	$logmess = "CheckMate the gameID: ".$_SESSION['gameID'];
	writeLog($logmess);

	mysql_query("UPDATE games SET gameMessage = 'checkMate', messageFrom = '".$currentPlayer."' WHERE gameID = ".$_SESSION['gameID']);

        calcEloRating(); //new EloRating function
	deleteChatMessage(); //chat
    }
    $tmpQuery = "SELECT gameMessage, messageFrom FROM games WHERE gameID = ".$_SESSION['gameID'];
    $tmpMessages = mysql_query($tmpQuery);
    $tmpMessage = mysql_fetch_array($tmpMessages, MYSQL_ASSOC);

    if ($tmpMessage['gameMessage'] == "draw"){
	$statusMessage .= "Game ended in a draw.<br>\n";
	$isGameOver = true;
    }

    if ($tmpMessage['gameMessage'] == "playerResigned"){
	$statusMessage .= $tmpMessage['messageFrom']." has resigned the game.<br>\n";
	$isGameOver = true;
    }

    if ($tmpMessage['gameMessage'] == "checkMate"){
	$statusMessage .= "Checkmate! ".$tmpMessage['messageFrom']." has won the game.<br>\n";
	$isGameOver = true;
	$isCheckMate = true;
    }
}

############################################################
function calcEloRating($gameID='',$aborted=0){
############################################################
    if($gameID == ''){
	$gameID = $_SESSION['gameID'];
	if (!checkGoodGame($gameID))
	return;
    }

    //check if start elo rate is changed
    changeStartRate();

    require 'ELOconfig.php';

    //get ending game information
    $BlackP = array();
    $WhiteP = array();
    $tmpplayerID = mysql_query("SELECT * FROM games WHERE gameID = ".$gameID."");
    $tmpplayerID = mysql_fetch_array($tmpplayerID, MYSQL_ASSOC);
    $BlackP['pID'] 		= $tmpplayerID['blackPlayer'];
    $WhiteP['pID'] 		= $tmpplayerID['whitePlayer'];

    //get old elorating info
    $tmpElorating = mysql_query("SELECT * FROM elorating WHERE playerID = ".$tmpplayerID['blackPlayer']." ORDER BY gameNR DESC");
    $rows = mysql_num_rows($tmpElorating);
    if ($rows == 0){
  	$BlackP['elorate'] 	= $CFG_ELO_START_RATE;
  	$BlackP['gameNR'] 	= 0;
    }else{
  	$tmpElorating = mysql_fetch_array($tmpElorating, MYSQL_ASSOC);
  	$BlackP['elorate'] 	= $tmpElorating['elorate'];
  	$BlackP['gameNR'] 	= $tmpElorating['gameNR'];
    }
    if($BlackP['elorate'] < 2000)
  	$BlackP['constat'] 	= 30;
    else if($BlackP['elorate'] > 2400)
  	$BlackP['constat'] 	= 10;
    else
	$BlackP['constat'] 	= 130 - ($BlackP['elorate'] / 20);

    $tmpElorating = mysql_query("SELECT * FROM elorating WHERE playerID = ".$tmpplayerID['whitePlayer']." ORDER BY gameNR DESC");
    $rows = mysql_num_rows($tmpElorating);
    if ($rows == 0){
  	$WhiteP['elorate'] 	= $CFG_ELO_START_RATE;
  	$WhiteP['gameNR'] 	= 0;
    }else{
  	$tmpElorating = mysql_fetch_array($tmpElorating, MYSQL_ASSOC);
  	$WhiteP['elorate'] 	= $tmpElorating['elorate'];
  	$WhiteP['gameNR'] 	= $tmpElorating['gameNR'];
    }
    if($WhiteP['elorate'] < 2000)
  	$WhiteP['constat'] 	= 30;
    else if($WhiteP['elorate'] > 2400)
  	$WhiteP['constat'] 	= 10;
    else
	$WhiteP['constat'] 	= 130 - ($WhiteP['elorate'] / 20);

    // elo calculation as discript on "http://gobase.org/studying/articles/elo/"
    $ELODIFFARRAY 	= array(   0,   20,   40,   60,   80,  100,  120,  140,  160,  180,  200,  300,  400);
    $EXPSCOREARRAY 	= array( 0.5, 0.53, 0.58, 0.62, 0.66, 0.69, 0.73, 0.76, 0.79, 0.82, 0.84, 0.93, 0.97);

    if($WhiteP['elorate'] < $BlackP['elorate'])
  	$playerdiff = $BlackP['elorate'] - $WhiteP['elorate'];
    else
  	$playerdiff = $WhiteP['elorate'] - $BlackP['elorate'];

    $expScore = 0;
    for ($i = 0; $i < 13; $i++) {
	if( $playerdiff < $ELODIFFARRAY[$i])
  	    break;
  	$expScore = $EXPSCOREARRAY[$i];
    }
    $expScore2 = 1 - $expScore;

    $updownrate = 0;
    $BlackP['gameabort'] = 0;
    $WhiteP['gameabort'] = 0;
    switch ($tmpplayerID['gameMessage']) {
  	case 'draw':
  	    //in a draw are the points only the half worth
  	    $WhiteP['constat'] = $WhiteP['constat'] / 2;
  	    $BlackP['constat'] = $BlackP['constat'] / 2;

  	    if ( $WhiteP['elorate'] == $BlackP['elorate'] ){
  		$WhiteP['newelorate'] = $WhiteP['elorate'];
  		$BlackP['newelorate'] = $BlackP['elorate'];
  	    }else if( $WhiteP['elorate'] < $BlackP['elorate'] ){//black has a better skill level
  		$updownrate = round($WhiteP['constat'] * ($expScore - $expScore2));
  		$WhiteP['newelorate'] = $WhiteP['elorate'] + $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] - $updownrate;
  	    }else{                                              //white has a better skill level
  		$updownrate = round($BlackP['constat'] * ($expScore - $expScore2));
                $WhiteP['newelorate'] = $WhiteP['elorate'] - $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] + $updownrate;
            }
            break;
	case 'playerResigned':
            if($tmpplayerID['messageFrom'] == 'white'){ 	//white loose the game
            	if ( $WhiteP['elorate'] == $BlackP['elorate'] ) //both player have the same skill level
            	    $updownrate = round($BlackP['constat'] * $expScore);
            	else if( $WhiteP['elorate'] < $BlackP['elorate'] )//black has a better skill level
                    $updownrate = round($BlackP['constat'] * (1 - $expScore));
                else                                              //white has a better skill level
                    $updownrate = round($BlackP['constat'] * $expScore);

                $WhiteP['newelorate'] = $WhiteP['elorate'] - $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] + $updownrate;
  		$WhiteP['gameabort'] = $aborted;
  	    }else{  							//black loose the game
		if ( $WhiteP['elorate'] == $BlackP['elorate'] )		//both player have the same skill level
            	    $updownrate = round($WhiteP['constat'] * $expScore);
            	else if( $WhiteP['elorate'] < $BlackP['elorate'] )  		//black has a better skill level
                    $updownrate = round($WhiteP['constat'] * $expScore);
                else                                                     	//white has a better skill level
                    $updownrate = round($WhiteP['constat'] * (1 - $expScore));

                $WhiteP['newelorate'] = $WhiteP['elorate'] + $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] - $updownrate;
  		$BlackP['gameabort'] = $aborted;
            }
            break;
	case 'checkMate':
            if($tmpplayerID['messageFrom'] == 'white'){ 			//white win the game
            	if ( $WhiteP['elorate'] == $BlackP['elorate'] )  	//both player have the same skill level
            	    $updownrate = round($WhiteP['constat'] * $expScore);
            	else if( $WhiteP['elorate'] < $BlackP['elorate'] )  		//black has a better skill level
                    $updownrate = round($WhiteP['constat'] * $expScore);
                else                                                     	//white has a better skill level
                    $updownrate = round($WhiteP['constat'] * (1 - $expScore));

                $WhiteP['newelorate'] = $WhiteP['elorate'] + $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] - $updownrate;
           }else{ 								//black win the game
           	if ( $WhiteP['elorate'] == $BlackP['elorate'] )			//both player have the same skill level
            	    $updownrate = round($BlackP['constat'] * $expScore);
            	else if( $WhiteP['elorate'] < $BlackP['elorate'] )  		//black has a better skill level
                    $updownrate = round($BlackP['constat'] * (1 - $expScore));
                else                                                     	//white has a better skill level
                    $updownrate = round($BlackP['constat'] * $expScore);

                $WhiteP['newelorate'] = $WhiteP['elorate'] - $updownrate;
  		$BlackP['newelorate'] = $BlackP['elorate'] + $updownrate;
           }
           break;
    }

    // now update the eleorating table
    $BlackP['gameNR'] = $BlackP['gameNR'] + 1;
    $WhiteP['gameNR'] = $WhiteP['gameNR'] + 1;
    mysql_query("INSERT INTO elorating (playerID, gameNR, gameID, elorate, gameabort ) VALUES (".$BlackP['pID'].",".$BlackP['gameNR'].",".$gameID.",".$BlackP['newelorate'].",".$BlackP['gameabort'].")");
    mysql_query("INSERT INTO elorating (playerID, gameNR, gameID, elorate, gameabort ) VALUES (".$WhiteP['pID'].",".$WhiteP['gameNR'].",".$gameID.",".$WhiteP['newelorate'].",".$WhiteP['gameabort'].")");

    //delete old entries
    deleteOldEloEntry($BlackP['pID'], $BlackP['gameNR']);
    deleteOldEloEntry($WhiteP['pID'], $WhiteP['gameNR']);
}

############################################################
function changeStartRate(){
############################################################
    require 'ELOconfig.php';
    $newSetting = "<?PHP\n";
    $newSetting .= "$" . "CFG_ELO_MAX_DB_LINES = ".$CFG_ELO_MAX_DB_LINES.";\n";
    $newSetting .= "$" . "CFG_ELO_MIN_TURN_ELO = ".$CFG_ELO_MIN_TURN_ELO.";\n";
    $newSetting .= "//TO CHANGE THE STARTING ELO RATE, MODIFY THIS VARIABLE\n";
    $newSetting .= "//BEFOR YOU CHANGE IT, BACKUP THE elorating TABLE\n";
    $newSetting .= "$" . "CFG_ELO_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    if ( $CFG_ELO_OLD_START_RATE == -1){ //initinal start
	$newSetting .= "//DON'T TOUCH THIS VARIABLE ########\n";
	$newSetting .= "$" . "CFG_ELO_OLD_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    }else if( $CFG_ELO_OLD_START_RATE != $CFG_ELO_START_RATE ){  //correct DB
	$eloDiff = $CFG_ELO_START_RATE - $CFG_ELO_OLD_START_RATE;
	$tmpRates = mysql_query("SELECT * FROM elorating");
        while($thisRate = mysql_fetch_array($tmpRates, MYSQL_ASSOC)){
	    $newrate = $thisRate['elorate'] + $eloDiff;
            mysql_query("UPDATE elorating SET elorate = ".$newrate." WHERE playerID = ".$thisRate['playerID']." AND gameNR = ".$thisRate['gameNR']." AND gameID = ".$thisRate['gameID']."");
	}
	$newSetting .= "//DON'T TOUCH THIS VARIABLE ########\n";
	$newSetting .= "$" . "CFG_ELO_OLD_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    }else
	return;
    
    $newSetting .= "?>";
    $configfile = "ELOconfig.php";
    writefile($configfile,$newSetting,0);
}

############################################################
function deleteOldEloEntry($pID, $lastGameNo){
############################################################
    require 'ELOconfig.php';
    $olderThenNo = $lastGameNo - $CFG_ELO_MAX_DB_LINES + 1;
    if ( $olderThenNo > 0 )
	mysql_query("DELETE FROM elorating WHERE playerID = ".$pID." AND gameNR < ".$olderThenNo.";");
}

############################################################
function checkGoodGame($gameID){
############################################################
    //return 0=badgame, 1=goodgame
    require 'ELOconfig.php';   
	
    $tmpNumMoves = mysql_query("SELECT COUNT(gameID) FROM history WHERE gameID = ".$gameID.";");
    $numMoves = mysql_result($tmpNumMoves,0);
    if($numMoves < $CFG_ELO_MIN_TURN_ELO){// it's not valid for ELO calculation
	return 0;
    }else{//valid game, so calc ELO for this game
	return 1;
    }
}

############################################################
function checkEndedGame($gameID){
############################################################
    require 'ELOconfig.php';

    //first check for normal game end
    $tmpGames = mysql_query("SELECT * FROM games WHERE gameID = ".$gameID." AND gameMessage = '' ;");
    if (mysql_num_rows($tmpGames) == 0)
	return;
    else{// found an aborted game
	//check how many turns has been done
	$tmpNumMoves = mysql_query("SELECT COUNT(gameID) FROM history WHERE gameID = ".$gameID.";");
	$numMoves = mysql_result($tmpNumMoves,0);

	$thisGame = mysql_fetch_array($tmpGames, MYSQL_ASSOC);
	/* based on number of moves, output current color's turn */
	if (($numMoves % 2) == 0){
	    $tmpCurMove = "white";
	    $pID = $thisGame['whitePlayer'];
	}else{
	    $tmpCurMove = "black";
	    $pID = $thisGame['blackPlayer'];
	}


	if($numMoves < $CFG_ELO_MIN_TURN_ELO){
	    // game aborted, but it's not valid for ELO calculation, mark only the player who abort this game
	    markAbortPlayer($pID,$gameID);

	    //write log
	    $logmess = "UID:".$pID." has aborted the gameID:".$gameID.", ELO was NOT calculated!";
	    writeLog($logmess);
	    return;
	}else{//valid game aborted, so calc ELO for this game
	    //set gamemessage to resign, message from the player how had to do the next move
	    $tmpQuery = "UPDATE games SET gameMessage = 'playerResigned', messageFrom = '".$tmpCurMove."' WHERE gameID = ".$gameID.";";
	    mysql_query($tmpQuery);

	    // now we can calculate the ELO-rate for this game
	    calcEloRating($gameID, 1);

	    //write log
	    $logmess = "UID:".$pID." has aborted the gameID:".$gameID.", ELO was calculated!";
	    writeLog($logmess);
	    
	    // clear chat for the ended game
	    deleteChatMessage();
	}
    }
}

############################################################
function markAbortPlayer($pID,$gameID){
############################################################
    require 'ELOconfig.php';
    //get old elorating info
    $Player = array();
    $tmpElorating = mysql_query("SELECT * FROM elorating WHERE playerID = ".$pID." ORDER BY gameNR DESC");
    $rows = mysql_num_rows($tmpElorating);
    if ($rows == 0){
  	$Player['newelorate'] 	= $CFG_ELO_START_RATE;
  	$Player['gameNR'] 	= 1;
    }else{
  	$tmpElorating = mysql_fetch_array($tmpElorating, MYSQL_ASSOC);
  	$Player['newelorate'] 	= $tmpElorating['elorate'];
  	$Player['gameNR'] 	= $tmpElorating['gameNR'] + 1;
    }
    $Player['gameabort'] = 1;
    $sqlstr = "INSERT INTO elorating (playerID, gameNR, gameID, elorate, gameabort ) VALUES (".$pID.",".$Player['gameNR'].",".$gameID.",".$Player['newelorate'].",1);";
    mysql_query($sqlstr);

    deleteOldEloEntry($pID, $Player['gameNR']);
}

############################################################
function deleteChatMessage(){
############################################################
    // clear chat for the ended game
    mysql_query("DELETE FROM chat WHERE gameID = ".$_SESSION['gameID']);
}


?>
