<?PHP

session_start();

/* check session status */
require 'sessioncheck.php';

/* neededfor fixOldPHPVersions() below */
require 'chessutils.php';

/* allow WebChess to be run on PHP systems < 4.1.0, using old http vars */
fixOldPHPVersions();

/* connect to the database */
require 'connectdb.php';

include_once('ELOconfig.php');
require 'chessdb.php';
include_once('utils.php');

############################################################
function genELOListing(){
############################################################
    $gamenr 	= array();
    $elorate	= array();
    $nick	= array();
    $activgames = array();
    $abortgames = array();
    $gamescount = array();
    $tmpPlayers = mysql_query("SELECT * FROM players");
    while($thisPlayer = mysql_fetch_array($tmpPlayers, MYSQL_ASSOC)){
	$tmpElorating = mysql_query("SELECT * FROM elorating WHERE playerID = ".$thisPlayer['playerID']." ORDER BY gameNR DESC");
  	$gamescount[$thisPlayer['playerID']] = mysql_num_rows($tmpElorating);
  	if ($gamescount[$thisPlayer['playerID']] > 0){
  	    $firstline = 0;
  	    $abortgames[$thisPlayer['playerID']] = 0;
  	    while($thisElorating = mysql_fetch_array($tmpElorating, MYSQL_ASSOC)){
  		if($firstline == 0)	{
  		    $gamenr[$thisPlayer['playerID']] = $thisElorating['gameNR'];
  		    $elorate[$thisPlayer['playerID']] = $thisElorating['elorate'];
  		    $firstline = 1;
  		}
  		$abortgames[$thisPlayer['playerID']] += $thisElorating['gameabort'];
  	    }
  	}else{
  	    $gamenr[$thisPlayer['playerID']] 	= 0;
    	    $elorate[$thisPlayer['playerID']] 	= 0;
    	}
    	$nick[$thisPlayer['playerID']]	= $thisPlayer['nick'];

        // get all active games
        $row = 0;
        $tmpGames = mysql_query("SELECT * FROM games WHERE ( whitePlayer = ".$thisPlayer['playerID']." OR blackPlayer = ".$thisPlayer['playerID']." ) AND gameMessage = ''");
        $row = mysql_num_rows($tmpGames);
        if ($row > 0)
             $activgames[$thisPlayer['playerID']] = $row;
        else
             $activgames[$thisPlayer['playerID']] = 0;

    }
    arsort($elorate);

    echo "<table border='0' width='80%'>\n";
    echo " <tr>\n";
    echo " <tr><th class='th_std' colspan='6'>ELO-rating</th></tr>\n";
    echo "  <th class='th_std'></th>\n";
    echo "  <th class='th_std'>Name</th>\n";
    echo "  <th class='th_std'>ELO</th>\n";
    echo "  <th class='th_std'>Reliability</th>\n";
    echo "  <th class='th_std'>active games</th>\n";
    echo "  <th class='th_std'>played games</th>\n";
    echo "</tr>\n";
    $tmpcount = 1;
    for($x=0;$x<sizeof($elorate);$x++) {
        $pID    = key($elorate);
        $elor   = current($elorate);
        $gNR    = $gamenr[$pID];
        $nic    = $nick[$pID];
        $actg	= $activgames[$pID];
        if($abortgames[$pID] == 0)
    	    $reli = 100;
        else{
	    $goodgames = $gamescount[$pID] - $abortgames[$pID];
            if($goodgames == 0)
        	$reli	= 0;
            else
        	$reli	= round($goodgames/$gamescount[$pID]*100);
    	}
    	next($elorate);
    	if($_SESSION['playerID'] == $pID){
    	    echo("<tr class='tr_usr'>\n");
    	    echo("<td></td>\n");
    	}else{
	    if($tmpcount%2)
            	echo("<tr class='tr_std'>\n");
	    else
	    	echo("<tr class='tr_std_l'>\n");
            echo("<form action='mainmenu.php' method='post'>\n");
            echo("<input type='hidden' name='ToDo' value='InvitePlayer'>\n");
            echo("<input type='hidden' name='color' value='random'>\n");
            echo("<input type='hidden' name='opponent' value='".$pID."'>\n");
            echo("<td><center><input type='submit' value='Invite'><center></td>\n");
    	}
    	echo("<td>".$nic."</td>");
    	if($elor == 0)
 	    echo("<td>not rated</td>");
    	else
            echo("<td>".$elor."</td>");
	echo("<td>".$reli."%</td>");
    	echo("<td>".$actg."</td>");
    	echo("<td>".$gNR."</td>");
    	echo("</form>\n");
    	echo("</tr>\n");
	$tmpcount ++;
    }
    echo "</table>\n";
    echo "<br>\n";
}
############################################################
function dispEloChangeWarning() {
############################################################
    require 'ELOconfig.php';
    if ( $CFG_ELO_OLD_START_RATE != -1 ){
	if ( $CFG_ELO_OLD_START_RATE != $CFG_ELO_START_RATE ){
	$infostr1  = "<b>The old starting ELO rate of ".$CFG_ELO_OLD_START_RATE." will be changed!</b><br> ";
    	$infostr1 .= "After the next calculation, the new starting ELO rate will be: <b>".$CFG_ELO_START_RATE."</b>\n"; 
	    echo "<table border='0' width='80%'>\n";
    	    echo " <tr><th class='th_std'>ELO Change Warning!</th></tr>\n";
            echo " <tr class='tr_std'>\n";
            echo "  <td>".$infostr1."</td>\n";
            echo " </tr>\n";
            echo "</table>\n";
            echo "<br>\n";
      	}
    }
}

############################################################
function dispEloInfoBox() {
############################################################
    require 'ELOconfig.php';
    $infostr1  = "ELO Calculation based on <a href='http://gobase.org/studying/articles/elo/'>this description</a><br> ";
    $infostr1 .= "New player are displayed with '<b>not rated</b>'<br>\n"; 
    $infostr1 .= "First ELO-rate used for calculation: <b> ".$CFG_ELO_START_RATE."</b><br>";
    
    $infostr2 .= "(savedGamesInDB - abortedGames) / savedGamesInDB * 100<br>";
    $infostr2 .= "savedGamesInDB = max. last <b>".$CFG_ELO_MAX_DB_LINES."</b> games<br>";
    $infostr2 .= "abortedGames = number of expired games in the last <b>".$CFG_ELO_MAX_DB_LINES."</b> games!";

    echo "<table border='0' width='80%'>\n";
    echo " <tr><th class='th_std' colspan='2' >ELO Info</th></tr>\n";
    echo " <tr><th class='th_std'>ELO-Calculation:</th><th class='th_std'>Reliability-Calculation:</th></tr>\n";
    echo " <tr class='tr_std'>\n";
    echo "  <td>".$infostr1."</td><td>".$infostr2."</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "<br>\n";
}

############################################################
function dispEloPage() {
############################################################
    echo "<html><head>\n";
    echo " <title>WebChess ELO</title>\n";
    echo " <link rel='stylesheet' type='text/css' href='webchess.css'>\n";
    echo "</head><body>\n";
    echo " <h1>ELO</h1>\n";
    echo " <center>\n";
    displayMenu(); 
    dispEloChangeWarning();
    genELOListing(); 
    dispEloInfoBox();
    dispfootNote();
    echo "</center>\n";
    echo "</body></html>\n";
}

dispEloPage();

mysql_close();

?>

