<?PHP
	
session_start();

/* load settings */
if (!isset($_CONFIG))
    require 'config.php';

/* load external functions for setting up new game */
require 'chessutils.php';
require 'chessconstants.php';
require 'newgame.php';
require 'chessdb.php';
require 'ELOconfig.php';
include_once('utils.php');

/* allow WebChess to be run on PHP systems < 4.1.0, using old http vars */
fixOldPHPVersions();

/* connect to database */
require 'connectdb.php';


/* Login, Logout and check for New User */
switch($_POST['LogInOut']){
    case 'NewUser':
	/* create new player */

	/* check for existing user with same nick */
	$tmpQuery = "SELECT playerID FROM players WHERE nick = '".$_POST['txtNick']."'";
	$existingUsers = mysql_query($tmpQuery);
	if (mysql_num_rows($existingUsers) > 0){
	    $_SESSION["msg_error"] = "Sorry, the nick you've chosen <b>'".$_POST['txtNick']."'</b> is already in use. Please try another.";
	    require 'newuser.php';
	    die();
	}
	
	$tmpQuery = "INSERT INTO players (password, firstName, lastName, nick) VALUES ('".$_POST['pwdPassword']."', '".$_POST['txtFirstName']."', '".$_POST['txtLastName']."', '".$_POST['txtNick']."')";
	mysql_query($tmpQuery);
    
	/* get ID of new player */
	$_SESSION['playerID'] = mysql_insert_id();

	//write log
	$logmess = "Add New User: ".$_POST['txtNick'];
	writeLog($logmess);

	/* set History format preference */
	$tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", 'history', '".$_POST['rdoHistory']."')";
	mysql_query($tmpQuery);

	/* set Theme preference */
	$tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", 'theme', '".$_POST['rdoTheme']."')";
	mysql_query($tmpQuery);

	/* set auto-reload preference */
	if (is_numeric($_POST['txtReload'])){
	    if (intval($_POST['txtReload']) >= $CFG_MINAUTORELOAD)
		$tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", 'autoreload', ".$_POST['txtReload'].")";
	    else
		$tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", 'autoreload', ".$CFG_MINAUTORELOAD.")";
	
	    mysql_query($tmpQuery);
    	}

	/* set email notification preference */
    	if ($CFG_USEEMAILNOTIFICATION){
	    $tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", 'emailnotification', '".$_POST['txtEmailNotification']."')";
	    mysql_query($tmpQuery);
    	}	
	/* no break, login user */

    case 'Login':
	/* check for a player with supplied nick and password */
	$tmpQuery = "SELECT * FROM players WHERE nick = '".$_POST['txtNick']."' AND password = '".$_POST['pwdPassword']."'";
	$tmpPlayers = mysql_query($tmpQuery);
	$tmpPlayer = mysql_fetch_array($tmpPlayers, MYSQL_ASSOC);

	/* if such a player exists, log him in... otherwise die */
	if ($tmpPlayer){
	    $_SESSION['playerID'] 	= $tmpPlayer['playerID'];
	    $_SESSION['lastInputTime'] 	= time();
	    $_SESSION['playerName'] 	= $tmpPlayer['firstName']." ".$tmpPlayer['lastName'];
	    $_SESSION['firstName'] 	= $tmpPlayer['firstName'];
	    $_SESSION['lastName'] 	= $tmpPlayer['lastName'];
	    $_SESSION['nick'] 		= $tmpPlayer['nick'];
	    //write log
	    $logmess = "LOGIN IP: ".getUserIP();
	    writeLog($logmess);
	}else{
	    //write log
	    $logmess = "LOGIN FAILED! Nickname: ".$_POST['txtNick']." IP: ".getUserIP();
	    writeLog($logmess);
	    $_SESSION["msg_error"] = "Invalid Nick/Password"; 
	    require 'index.php';
	   die();
	}


	/* load user preferences */
	$tmpQuery = "SELECT * FROM preferences WHERE playerID = ".$_SESSION['playerID'];
	$tmpPreferences = mysql_query($tmpQuery);

	$isPreferenceFound['history'] 		= false;
	$isPreferenceFound['theme'] 		= false;
	$isPreferenceFound['autoreload'] 	= false;
	$isPreferenceFound['emailnotification'] = false;
			
	while($tmpPreference = mysql_fetch_array($tmpPreferences, MYSQL_ASSOC)){
	    switch($tmpPreference['preference']){
		case 'history':
		case 'theme':
		    /* setup SESSION var of name pref_PREF, like pref_history */
		    $_SESSION['pref_'.$tmpPreference['preference']] = $tmpPreference['value'];
		    break;
		case 'emailnotification':
		    if ($CFG_USEEMAILNOTIFICATION)
			$_SESSION['pref_emailnotification'] = $tmpPreference['value'];
		    break;
		case 'autoreload':
		    if (is_numeric($tmpPreference['value'])){
			if (intval($tmpPreference['value']) >= $CFG_MINAUTORELOAD)
			    $_SESSION['pref_autoreload'] = intval($tmpPreference['value']);
			else
			    $_SESSION['pref_autoreload'] = $CFG_MINAUTORELOAD;
		    }else
			$_SESSION['pref_autoreload'] = $CFG_MINAUTORELOAD;
		    break;
	    }
	    $isPreferenceFound[$tmpPreference['preference']] = true;
	}

	/* look for missing preference and fix */
	foreach (array_keys($isPreferenceFound, false) as $missingPref){
	    $defaultValue = "";
	    switch($missingPref){
		case 'history':
		    $defaultValue = "pgn";
		    break;
		case 'theme':
		    $defaultValue = "beholder";
		    break;
		case 'autoreload':
		    $defaultValue = $CFG_MINAUTORELOAD;
		    break;
		case 'emailnotification':
		    $defaultValue = "";
		    break;
	    }
	    $tmpQuery = "INSERT INTO preferences (playerID, preference, value) VALUES (".$_SESSION['playerID'].", '".$missingPref."', '".$defaultValue."')";
	    mysql_query($tmpQuery);

	    /* setup SESSION var of name pref_PREF, like pref_history */
	    if ($CFG_USEEMAILNOTIFICATION || ($missingPref != 'emailnotification'))
		$_SESSION['pref_'.$missingPref] =  $defaultValue;
	}
	break;
    case 'Logout':	
	//write log
	$logmess = "LOGOUT";
	writeLog($logmess);
        
	// clear sessionvaribles
	$_SESSION['playerID'] 		= -1;
	$_SESSION['lastInputTime'] 	= '';
	$_SESSION['playerName'] 	= '';
	$_SESSION['firstName'] 		= '';
	$_SESSION['lastName'] 		= '';
	$_SESSION['nick'] 		= '';

	require 'index.php'; 
    	die();
	break;
}

/* check session status */
require 'sessioncheck.php';


/* cleanup dead games */
/* determine threshold for oldest game permitted */
$targetDate = date("Y-m-d", mktime(0,0,0, date('m'), date('d') - $CFG_EXPIREGAME, date('Y')));

/* find out which games are older */
$tmpQuery = "SELECT gameID FROM games WHERE lastMove < '".$targetDate."'";
$tmpOldGames = mysql_query($tmpQuery);

/* for each older game... */
while($tmpOldGame = mysql_fetch_array($tmpOldGames, MYSQL_ASSOC)){
    //write log
    $logmess = "Start cleanDB for gameID: ".$tmpOldGame['gameID'];
    writeLog($logmess);

    /* ... first test if the game realy ended, if not so we need to calc the ELO.. */
    checkEndedGame($tmpOldGame['gameID']);

    /* ... clear the history... */
    mysql_query("DELETE FROM history WHERE gameID = ".$tmpOldGame['gameID']);

    /* ... and the board... */
    mysql_query("DELETE FROM pieces WHERE gameID = ".$tmpOldGame['gameID']);

    /* ... and the messages... */
    mysql_query("DELETE FROM messages WHERE gameID = ".$tmpOldGame['gameID']);

    /* ... and finally the game itself from the database */
    mysql_query("DELETE FROM games WHERE gameID = ".$tmpOldGame['gameID']);
}


$errMsg = "";
switch($_POST['ToDo']){
    case 'InvitePlayer':
	/* prevent multiple pending requests between two players with the same originator */
	$tmpQuery = "SELECT gameID FROM games WHERE gameMessage = 'playerInvited'";
	$tmpQuery .= " AND ((messageFrom = 'white' AND whitePlayer = ".$_SESSION['playerID']." AND blackPlayer = ".$_POST['opponent'].")";
	$tmpQuery .= " OR (messageFrom = 'black' AND whitePlayer = ".$_POST['opponent']." AND blackPlayer = ".$_SESSION['playerID']."))";
	$tmpExistingRequests = mysql_query($tmpQuery);

	if (mysql_num_rows($tmpExistingRequests) == 0){
	    if (!minimum_version("4.2.0"))
		init_srand();

	    if ($_POST['color'] == 'random')
		$tmpColor = (mt_rand(0,1) == 1) ? "white" : "black";
	    else
		$tmpColor = $_POST['color'];

	    $tmpQuery = "INSERT INTO games (whitePlayer, blackPlayer, gameMessage, messageFrom, dateCreated, lastMove) VALUES (";
	    if ($tmpColor == 'white')
		$tmpQuery .= $_SESSION['playerID'].", ".$_POST['opponent'];
	    else
		$tmpQuery .= $_POST['opponent'].", ".$_SESSION['playerID'];

	    $tmpQuery .= ", 'playerInvited', '".$tmpColor."', NOW(), NOW())";
	    mysql_query($tmpQuery);

	    /* if email notification is activated... */
	    if ($CFG_USEEMAILNOTIFICATION){
		/* if opponent is using email notification... */
		$tmpOpponentEmail = mysql_query("SELECT value FROM preferences WHERE playerID = ".$_POST['opponent']." AND preference = 'emailNotification'");
		if (mysql_num_rows($tmpOpponentEmail) > 0){
		    $opponentEmail = mysql_result($tmpOpponentEmail, 0);
		    if ($opponentEmail != ''){
			/* notify opponent of invitation via email */
			webchessMail('invitation', $opponentEmail, '', $_SESSION['nick']);
		    }
		}
	    }
	    //write log
	    $logmess = "Invited UID: ".$_POST['opponent']." color: ".$_POST['color'];
	    writeLog($logmess);
	}
	break;

    case 'ResponseToInvite':
	if ($_POST['response'] == 'accepted'){
	    /* update game data */
	    $tmpQuery = "UPDATE games SET gameMessage = '', messageFrom = '' WHERE gameID = ".$_POST['gameID'];
	    mysql_query($tmpQuery);

	    /* setup new board */
	    $_SESSION['gameID'] = $_POST['gameID'];
	    createNewGame($_POST['gameID']);
	    saveGame();
	    
	    //write log
	    $logmess = "Response To Invite accepted. gameID: ".$_SESSION['gameID'];
	    writeLog($logmess);
	}else{
	    $tmpQuery = "UPDATE games SET gameMessage = 'inviteDeclined', messageFrom = '".$_POST['messageFrom']."' WHERE gameID = ".$_POST['gameID'];
	    mysql_query($tmpQuery);
	    //write log
	    $logmess = "Response To Invite rejected. gameID: ".$_SESSION['gameID'];
	    writeLog($logmess);
	}
	break;

    case 'WithdrawRequest':
	/* get opponent's player ID */
	$tmpOpponentID = mysql_query("SELECT whitePlayer FROM games WHERE gameID = ".$_POST['gameID']);
	if (mysql_num_rows($tmpOpponentID) > 0){
	    $opponentID = mysql_result($tmpOpponentID, 0);

	    if ($opponentID == $_SESSION['playerID']){
		$tmpOpponentID = mysql_query("SELECT blackPlayer FROM games WHERE gameID = ".$_POST['gameID']);
		$opponentID = mysql_result($tmpOpponentID, 0);
	    }

	    $tmpQuery = "DELETE FROM games WHERE gameID = ".$_POST['gameID'];
	    mysql_query($tmpQuery);

	    /* if email notification is activated... */
	    if ($CFG_USEEMAILNOTIFICATION){
		/* if opponent is using email notification... */
		$tmpOpponentEmail = mysql_query("SELECT value FROM preferences WHERE playerID = ".$opponentID." AND preference = 'emailNotification'");
		if (mysql_num_rows($tmpOpponentEmail) > 0){
		    $opponentEmail = mysql_result($tmpOpponentEmail, 0);
		    if ($opponentEmail != ''){
			/* notify opponent of invitation via email */
			webchessMail('withdrawal', $opponentEmail, '', $_SESSION['nick']);
		    }
		}
	    }
	}
	break;
}


/* set default playing mode to different PCs (as opposed to both players sharing a PC) */
$_SESSION['isSharedPC'] = false;


############################################################
function dispJSMainMenu() {
############################################################
    echo "<script type='text/javascript'>\n";
    echo " function sendResponse(responseType, messageFrom, gameID){\n";
    echo "  document.responseToInvite.response.value = responseType;\n";
    echo "  document.responseToInvite.messageFrom.value = messageFrom;\n";
    echo "  document.responseToInvite.gameID.value = gameID;\n";
    echo "  document.responseToInvite.submit();\n";
    echo " }\n";
    echo " function loadGame(gameID){\n";
    echo "  if (document.existingGames.rdoShare[0].checked)\n";
    echo "   document.existingGames.action = \"opponentspassword.php\";\n";
    echo "  document.existingGames.gameID.value = gameID;\n";
    echo "  document.existingGames.submit();\n";
    echo " }\n";
    echo " function withdrawRequest(gameID){\n";
    echo "  document.withdrawRequestForm.gameID.value = gameID;\n";
    echo "  document.withdrawRequestForm.submit();\n";
    echo " }\n";
    echo " function loadEndedGame(gameID){\n";
    echo "  document.existingGames.gameID.value = gameID;\n";
    echo "  document.existingGames.submit();\n";
    echo " }\n";
    echo "</script>\n";
}

############################################################
function dispCurInvitations() {
############################################################
    /* if game is marked playerInvited and the invite is from the current player */
    $tmpQuery = "SELECT * FROM games WHERE (gameMessage = 'playerInvited' AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'white') OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'black'))";

    /* OR game is marked inviteDeclined and the response is from the opponent */
    $tmpQuery .= ") OR (gameMessage = 'inviteDeclined' AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'black') OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'white')))  ORDER BY dateCreated";

    $tmpGames = mysql_query($tmpQuery);
    if (mysql_num_rows($tmpGames) != 0){
    	echo "<form name='withdrawRequestForm' action='mainmenu.php' method='post'>\n";
    	echo "<table border='0' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='4'>Current Invitations</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>Opponent</th>\n";
    	echo "  <th class='th_std'>Your Color</th>\n";
    	echo "  <th class='th_std'>Status</th>\n";
    	echo "  <th class='th_std'>Withdraw Request</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = mysql_fetch_array($tmpGames, MYSQL_ASSOC)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");
	    echo("<td>");
	    /* get opponent's nick */
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID'])
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['blackPlayer']);
	    else
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['whitePlayer']);
	    $opponent = mysql_result($tmpOpponent,0);
	    echo($opponent);

	    /* Your Color */
	    echo ("</td><td>");
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID'])
	    	echo ("White");
	    else
	    	echo ("Black");

	    /* Status */
	    echo ("</td><td>");
	    if ($tmpGame['gameMessage'] == 'playerInvited')
	    	echo ("Response pending");
	    else if ($tmpGame['gameMessage'] == 'inviteDeclined')
	    	echo ("Invitation declined");

	    /* Withdraw Request */
	    echo ("</td><td align='center'>");
	    echo ("<input type='button' value='Withdraw' onclick=\"withdrawRequest(".$tmpGame['gameID'].")\">");
	    echo("</td></tr>\n");
	    $tmpcount ++;
    	}
        echo "</table>\n";
        echo "<input type='hidden' name='gameID' value=''>\n";
        echo "<input type='hidden' name='ToDo' value='WithdrawRequest'>\n";
        echo "</form>\n";    
        echo "<br>\n";
    }
}

############################################################
function dispResInvitations() {
############################################################
    $tmpQuery = "SELECT * FROM games WHERE gameMessage = 'playerInvited' AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'black') OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'white')) ORDER BY dateCreated";
    $tmpGames = mysql_query($tmpQuery);

    if (mysql_num_rows($tmpGames) != 0){
    	echo "<form name='responseToInvite' action='mainmenu.php' method='post'>\n";
    	echo "<table border='0' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='3'>Respond to a player's invitation</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>Opponent</th>\n";
    	echo "  <th class='th_std'>Your Color</th>\n";
    	echo "  <th class='th_std'>Response</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = mysql_fetch_array($tmpGames, MYSQL_ASSOC)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");
	    echo("<td>");
	    /* get opponent's nick */
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID'])
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['blackPlayer']);
	    else
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['whitePlayer']);
	    $opponent = mysql_result($tmpOpponent,0);
	    echo($opponent);

	    /* Your Color */
	    echo ("</td><td>");
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID']){
	    	echo ("White");
	    	$tmpFrom = "white";
	    }else{
	    	echo ("Black");
	    	$tmpFrom = "black";
	    }

	    /* Response */
	    echo ("</td><td align='center'>");
	    echo ("<input type='button' value='Accept' onclick=\"sendResponse('accepted', '".$tmpFrom."', ".$tmpGame['gameID'].")\">");
	    echo ("<input type='button' value='Decline' onclick=\"sendResponse('declined', '".$tmpFrom."', ".$tmpGame['gameID'].")\">");

	    echo("</td></tr>\n");
	    $tmpcount ++;
    	}
        echo "</table>\n";
        echo "<input type='hidden' name='response' value=''>\n";
        echo "<input type='hidden' name='messageFrom' value=''>\n";
        echo "<input type='hidden' name='gameID' value=''>\n";
        echo "<input type='hidden' name='ToDo' value='ResponseToInvite'>\n";
        echo "</form>\n";
        echo "<br>\n";
    }
}

############################################################
function dispExistGames() {
############################################################
    $tmpGames = mysql_query("SELECT * FROM games WHERE gameMessage = '' AND (whitePlayer = ".$_SESSION['playerID']." OR blackPlayer = ".$_SESSION['playerID'].") ORDER BY dateCreated");

    if (mysql_num_rows($tmpGames) != 0){
    	echo "<form name='existingGames' action='chess.php' method='post'>\n";
    	echo "<table border='0' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='6'>Continue an existing game</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>Opponent</th>\n";
    	echo "  <th class='th_std'>Your Color</th>\n";
    	echo "  <th class='th_std'>Current Turn</th>\n";
    	echo "  <th class='th_std'>Start Date</th>\n";
    	echo "  <th class='th_std'>Last Move</th>\n";
    	echo "  <th class='th_std'>Msg</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = mysql_fetch_array($tmpGames, MYSQL_ASSOC)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");
	    echo("<td>");
	    /* get opponent's nick */
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID'])
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['blackPlayer']);
	    else
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['whitePlayer']);
	    $opponent = mysql_result($tmpOpponent,0);

	    echo("<a href='javascript:loadGame(".$tmpGame['gameID'].")'>".$opponent."</a>");

	    /* Your Color */
	    echo ("</td><td>");
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID']){
	    	echo ("White");
	    	$tmpColor = "white";
	    }else{
	    	echo ("Black");
	        $tmpColor = "black";
	    }

	    /* Current Turn */
	    echo ("</td><td>");
	    /* get number of moves from history */
	    $tmpNumMoves = mysql_query("SELECT COUNT(gameID) FROM history WHERE gameID = ".$tmpGame['gameID']);
	    $numMoves = mysql_result($tmpNumMoves,0);

	    /* based on number of moves, output current color's turn */
	    if (($numMoves % 2) == 0)
	    	$tmpCurMove = "white";
	    else
	    	$tmpCurMove = "black";

	    if ($tmpCurMove == $tmpColor)
	        echo("Your move");
	    else
	    	echo("Opponent's move");

	    /* Start Date */
	    echo ("</td><td>".$tmpGame['dateCreated']);

	    /* Last Move */
	    echo ("</td><td>".$tmpGame['lastMove']."\n");
			
	    /* New Msg */
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID']){
	    	if ($tmpGame['msgforW'] == 1)
		    echo ("</td><td align='center'><img src='images/msg.gif' width='26' height='26' border='0' alt='X'></td></tr>\n");
	    	else
		    echo ("</td><td></td></tr>\n");	
	    }else{
	    	if ($tmpGame['msgforB'] == 1)
		    echo ("</td><td align='center'><img src='images/msg.gif' width='26' height='26' border='0' alt='X'></td></tr>\n");
	    	else
		    echo ("</td><td></td></tr>\n");
	    }
	    $tmpcount ++;
    	}

    	/* share PC */
	if($tmpcount%2)
           echo("<tr class='tr_std'>");
        else
	   echo("<tr class='tr_std_l'>");
	echo ("<td colspan='3'>Will both players play from the same PC?</td>");
    	echo ("<td><input type='radio' name='rdoShare' value='yes'> Yes</td>");
    	echo ("<td><input type='radio' name='rdoShare' value='no' checked> No</td>\n");
	echo ("<td></td></tr>");
    	echo "</table>\n";
    	echo "<input type='hidden' name='gameID' value=''>\n";
    	echo "<input type='hidden' name='sharePC' value='no'>\n";
    	echo "</form>\n";
    	echo "<br>\n";
    }
}

############################################################
function dispEndedGames() {
############################################################
    $tmpGames = mysql_query("SELECT * FROM games WHERE (gameMessage <> '' AND gameMessage <> 'playerInvited' AND gameMessage <> 'inviteDeclined') AND (whitePlayer = ".$_SESSION['playerID']." OR blackPlayer = ".$_SESSION['playerID'].") ORDER BY lastMove DESC");

    if (mysql_num_rows($tmpGames) != 0){
    	echo "<form name='endedGames' action='chess.php' method='post'>\n";
    	echo "<table border='0' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='5'>Ended games</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>Opponent</th>\n";
    	echo "  <th class='th_std'>Your Color</th>\n";
    	echo "  <th class='th_std'>Status</th>\n";
    	echo "  <th class='th_std'>Start Date</th>\n";
    	echo "  <th class='th_std'>Last Move</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = mysql_fetch_array($tmpGames, MYSQL_ASSOC)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	  	echo("<tr class='tr_std_l'>");
	    echo("<td>");
	    /* get opponent's nick */
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID'])
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['blackPlayer']);
	    else
	    	$tmpOpponent = mysql_query("SELECT nick FROM players WHERE playerID = ".$tmpGame['whitePlayer']);
	
	    $opponent = mysql_result($tmpOpponent,0);
	    echo("<a href='javascript:loadEndedGame(".$tmpGame['gameID'].")'>".$opponent."</a>");

	    /* Your Color */
	    echo ("</td><td>");
	    if ($tmpGame['whitePlayer'] == $_SESSION['playerID']){
	    	echo ("White");
	    	$tmpColor = "white";
	    }else{
	    	echo ("Black");
	        $tmpColor = "black";
	    }

	    /* Status */
	    if (is_null($tmpGame['gameMessage']))
	    	echo("</td><td>&nbsp;");
	    else{
	    	if ($tmpGame['gameMessage'] == "draw")
		    echo("</td><td>Ended in draw");
	    	else if ($tmpGame['gameMessage'] == "stalemate")
		    echo("</td><td>Ended in stalemate");
	    	else if ($tmpGame['gameMessage'] == "playerResigned")
		    echo("</td><td>".$tmpGame['messageFrom']." has resigned");
	    	else if (($tmpGame['gameMessage'] == "checkMate") && ($tmpGame['messageFrom'] == $tmpColor))
		    echo("</td><td>Checkmate, you won!");
	    	else if ($tmpGame['gameMessage'] == "checkMate")
		    echo("</td><td>Checkmate, you lost");
	    	else
		    echo("</td><td>&nbsp;");
	    }

	    /* Start Date */
	    echo ("</td><td>".$tmpGame['dateCreated']);

	    /* Last Move */
	    echo ("</td><td>".$tmpGame['lastMove']."</td></tr>\n");
	    $tmpcount ++;
    	}
    	echo "</table>\n";
    	echo "<input type='hidden' name='gameID' value=''>\n";
    	echo "<input type='hidden' name='sharePC' value='no'>\n";
    	echo "</form>\n";
    	echo "<br>\n";
    }
}

############################################################
function dispWarnBox() {
############################################################
    require 'config.php';
    require 'ELOconfig.php';
    $warnstr  = "Games will expire WITHOUT NOTICE if a move isn't made after ".$CFG_EXPIREGAME." days! ";
    $warnstr .= "Those games will be used for ELO calculation when at least ".$CFG_ELO_MIN_TURN_ELO." ";
    $warnstr .= "half turns where made! In this case the last user which didn't move will be declared ";
    $warnstr .= "as having resigned!";

    echo "<table border='0' width='80%'>\n";
    echo " <tr><th class='th_std'>Warning</th></tr>\n";
    echo " <tr class='tr_std'>\n";
    echo "  <td>\n";
    echo $warnstr;
    echo "  </td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "<br>\n";
}

############################################################
function dispMainMenuPage() {
############################################################
    echo "<html><head>\n";
    echo " <title>WebChess Main Menu</title>\n";
    echo " <link rel='stylesheet' type='text/css' href='webchess.css'>\n";
    dispJSMainMenu();
    echo "</head><body>\n";
    echo " <h1>WebChess Main Menu</h1>\n";
    echo " <center>\n";
    displayMenu();
    dispCurInvitations();
    dispResInvitations();
    dispExistGames();
    dispEndedGames();
    dispWarnBox();
    dispfootNote();
    echo " </center>\n";
    echo "</body></html>\n";
}

dispMainMenuPage();

mysql_close();
?>
